#include "technix.h"

// Declares that 'main' is external to this header.
// This is the entry point of the original application that is called
// after the simulation is initialized.
extern int main(void);

// (Private) struct that contains the handles to the host functions.
static SimulationHost __tx_host;

// This is the entry point to the DLL.
// A parameter is passed in that contains the function handles that the tx_functions need to call the simulation host.
//static void tx_main(SimulationHost host)
void tx_main(SimulationHost host)
{
    // Setup the host struct.
    __tx_host = host;
    // Call the main of the program.
    main();
}

void tx_gpio_pin_set(uint32_t port_id, uint32_t pin_id, bool value)
{
    __tx_host.tx_gpio_pin_set(port_id, pin_id, value);
}

bool tx_gpio_pin_get(uint32_t port_id, uint32_t pin_id)
{
    return __tx_host.tx_gpio_pin_get(port_id, pin_id);
}


uint32_t tx_adc_read(uint32_t adc_id, uint32_t channel_id)
{
    return __tx_host.tx_adc_read(adc_id, channel_id);
}

void tx_dac_write(uint32_t dac_id, uint32_t channel_id, int32_t value)
{
    __tx_host.tx_dac_write(dac_id, channel_id, value);
}


uint8_t tx_uart_receive(uint32_t uart_id)
{
    return __tx_host.tx_uart_receive(uart_id);
}

void tx_uart_send(uint32_t uart_id, uint8_t value)
{
    __tx_host.tx_uart_send(uart_id, value);
}

uint8_t tx_spi_receive(uint32_t spi_id)
{
    return __tx_host.tx_spi_receive(spi_id);
}

void tx_spi_send(uint32_t spi_id, uint8_t value)
{
    __tx_host.tx_spi_send(spi_id, value);
}


void tx_cycle()
{
    __tx_host.tx_cycle();
}


uint32_t tx_time_seconds()
{
    return __tx_host.tx_time_seconds();
}

uint32_t tx_time_millis()
{
    return __tx_host.tx_time_millis();
}

uint32_t tx_time_micros()
{
    return __tx_host.tx_time_micros();
}

uint32_t tx_time_nanos()
{
    return __tx_host.tx_time_nanos();
}

uint32_t tx_time_quanta()
{
    return __tx_host.tx_time_quanta();
}


void tx_delay_seconds(uint32_t delay)
{
    __tx_host.tx_delay_seconds(delay);
}

void tx_delay_millis(uint32_t delay)
{
    __tx_host.tx_delay_millis(delay);
}

void tx_delay_micros(uint32_t delay)
{
    __tx_host.tx_delay_micros(delay);
}

void tx_delay_nanos(uint32_t delay)
{
    __tx_host.tx_delay_nanos(delay);
}

void tx_delay_quanta(uint32_t delay)
{
    __tx_host.tx_delay_quanta(delay);
}
